# Code generated by rgnonomic/rgo; DO NOT EDIT.

#' @useDynLib wordcount

#' count
#'
#' Count returns a list of counts of occurrences of words.
#' 
#' @param words is a character vector
#' @return A vector
#' @seelso <https://godoc.org/github.com/rgonomic/rgo/examples/wordcount#Count>
#' @export
count <- function(words) {
	if (!is.character(words) && !is.null(words)) {
		stop("Argument 'words' must be of type 'character' or NULL.")
	}
	.Call("count", words, PACKAGE = "wordcount")
}

#' count_with_length
#'
#' CountWithLength returns a list of counts of occurrences of words,
#' redundantly keeping the word length.
#' 
#' @param words is a character vector
#' @return A vector
#' @seelso <https://godoc.org/github.com/rgonomic/rgo/examples/wordcount#CountWithLength>
#' @export
count_with_length <- function(words) {
	if (!is.character(words) && !is.null(words)) {
		stop("Argument 'words' must be of type 'character' or NULL.")
	}
	.Call("count_with_length", words, PACKAGE = "wordcount")
}

#' print_count_with_length
#'
#' PrintUniqueWithLength prints the Go syntax representation of a.
#' 
#' @param a is a vector
#' @seelso <https://godoc.org/github.com/rgonomic/rgo/examples/wordcount#PrintCountWithLength>
#' @export
print_count_with_length <- function(a) {
	if (!is.vector(a) && !is.null(a)) {
		stop("Argument 'a' must be of type 'vector' or NULL.")
	}
	.Call("print_count_with_length", a, PACKAGE = "wordcount")
}

#' unique
#'
#' Unique returns a vector of unique words from the words input vector
#' sorted ascending.
#' 
#' @param words is a character vector
#' @return A character vector
#' @seelso <https://godoc.org/github.com/rgonomic/rgo/examples/wordcount#Unique>
#' @export
unique <- function(words) {
	if (!is.character(words) && !is.null(words)) {
		stop("Argument 'words' must be of type 'character' or NULL.")
	}
	.Call("unique", words, PACKAGE = "wordcount")
}

#' unique_with_length
#'
#' UniqueWithLength returns a vector of unique words from the words input
#' vector sorted ascending, redundantly keeping the word length.
#' 
#' @param words is a character vector
#' @return A list
#' @seelso <https://godoc.org/github.com/rgonomic/rgo/examples/wordcount#UniqueWithLength>
#' @export
unique_with_length <- function(words) {
	if (!is.character(words) && !is.null(words)) {
		stop("Argument 'words' must be of type 'character' or NULL.")
	}
	.Call("unique_with_length", words, PACKAGE = "wordcount")
}

#' print_unique_with_length
#'
#' PrintUniqueWithLength prints the Go syntax representation of a.
#' 
#' @param a is a list
#' @seelso <https://godoc.org/github.com/rgonomic/rgo/examples/wordcount#PrintUniqueWithLength>
#' @export
print_unique_with_length <- function(a) {
	if (!is.list(a)) {
		stop("Argument 'a' must be of type 'list'.")
	}
	.Call("print_unique_with_length", a, PACKAGE = "wordcount")
}
